/*
 * Chess game implementation.
 * By Carlos Varela  <cvarela@uiuc.edu>  February, 1997
 * 
 */

package chess;

public class CheckMateException extends Exception implements java.io.Serializable {

  boolean color;      // Who did checkmate
  MoveTree moveTree;  // If not already in checkmate, this is the proof. 

  CheckMateException(boolean color){
    this.color = color;
  }

  CheckMateException(boolean color, MoveTree moveTree){
    this.color = color;
    this.moveTree = moveTree;
  }

  public boolean getColor(){
    return color;
  }

  /**
   * getMove returns the move that creates the checkmate
   */
  public Move getMove(){
    if (moveTree.getMove() instanceof Move)
      return (Move) moveTree.getMove();
      return null;
  }
}
