/*
 * Chess game implementation.
 * By Carlos Varela  <cvarela@uiuc.edu>  February, 1997
 * 
 */

package chess;

/**
 * CutSearchTreeException is an exception that gets thrown
 * when the search tree should be cut.  It contains a value
 * indicating the static function to be used at the cutting
 * branch.
 */

public class CutSearchTreeException extends Exception implements java.io.Serializable {

  int value;  // value to be used at this branch in the search tree.

  CutSearchTreeException(int value){
    this.value = value;
  }

  public int getValue(){
    return value;
  }
}
