/*
 * Chess game implementation.
 * By Carlos Varela.  February, 1997
 *
 * Knight class.  Contains a chess piece representing a knight.
 */

package chess;

import java.util.*;

class Knight extends Piece implements java.io.Serializable {

  Knight(boolean col){
    value = (col? 300 : -300);
    color = col;
  }

  Vector generateMoves(){
    Vector knightMoves = new Vector(8);
    char c = getColumn();
    int r = getRow();
    Board b = getBoard();
    Piece p;
    // Knight movements
    
                                 // Upward moves 
    try {
	int ri = r + 2;
	char ci = (char) (c + 1);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	 
    try {
	int ri = r + 2;
	char ci = (char) (c - 1);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */

    try {
	int ri = r + 1;
	char ci = (char) (c + 2);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	 
    try {
	int ri = r + 1;
	char ci = (char) (c - 2);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	     
                                 // Downward moves 
    try {
	int ri = r - 2;
	char ci = (char) (c + 1);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	 
    try {
	int ri = r - 2;
	char ci = (char) (c - 1);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */

    try {
	int ri = r - 1;
	char ci = (char) (c + 2);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	 
    try {
	int ri = r - 1;
	char ci = (char) (c - 2);
	if ((p = b.getPieceAt(ci,ri)) != null){  // A piece is in the way
	  if (p.color() != color())            // Can eat if opposite color.
	    knightMoves.addElement(new Move(this, c, r, ci, ri));
	} else
	  knightMoves.addElement(new Move(this, c, r, ci, ri));
    } catch (ArrayIndexOutOfBoundsException e){};  /* Out of board */
	 	 
    return knightMoves;
  }

  boolean isProtected(){
    // Incomplete.
    return true;
  }

  boolean attacksCenter(){
    // Incomplete.
    return false;
  }

  boolean makesCheck(){
    // Incomplete.
    return false;
  }

  public String toString(){
    return ((color == Game.WHITE)? "N" : "n");
  }

}
